<?php
/*
* MBot Contact advanced ignore PHP Script [ANSI]
* Russian language
*  2011 Skurat Denis (a.k.a. Dionys)
* @contact: skiner@inbox.ru
* 
* Source - Temp Ignore contact
* by AVol Wert
*/

/* CONFIGURATION */
define('SCRIPT_NAME',		'Contact advanced ignore');	// Script name.
define('SCRIPT_VERSION',	'1.0.0.7');					// Script version.
define('SCRIPT_CFG',		'AdvIgnore');				// Script config section.
define('SYM_ENTER',			chr(0x0D).chr(0x0A));		// Enter
define('DISPLAY_POPUP',		true);						// Show a PopUp when ingnored user had messaged you.
define('WARN_CONTACT',		true);						// Warn the ignored contact that he is being ignored by sending him a message each time he messages you.
define('WARN_REASON',		true);						// If WARN_CONTACT true. Use "ignoring reason" message for each contact.
define('WARN_MESSAGE',		":    %s.". SYM_ENTER ." %s .");	// If WARN_CONTACT true. The message that will be send to the contact.
define('WARN_DELAY',		300);						// If WARN_CONTACT true. Warn-message will only be sent once every "WARN_DELAY" seconds if the contact continue sending you messages, to avoid an infinite loop with contacts that have autorepliers.
define('WARN_LOG',			true);						// Save a LOG file of the ignored contacts that have sent you messages. This will be saved to /mbot/ignore_log.txt
define('INCLUDE_PATH',		realpath('./') .'/mbot/scripts/include');
define('WORKING_PATH',		realpath('./') .'/mbot/scripts/autoload/AdvIgnore');
define('GMT_OFFSET',		'GMT+4');					// GMT OffSet.
/* END CONFIGURATION */

include (INCLUDE_PATH . '/conv.libphp4.php');

function mbot_load()
{
	if (MBOT_VERSION >= 0x01000000)
	{
		$icon = mb_IconLoadSys(IDI_ERROR);

		mb_SelfRegister(MB_EVENT_MSG_IN | MB_EVENT_MENU_COMMAND, 1);
		mb_SelfSetInfo('    v.'. SCRIPT_VERSION);
		mb_Echo('    v.'. SCRIPT_VERSION .' .'. SYM_ENTER);
		mb_MenuAdd('[AI] ', 0, 'menu_adv_ignore', $icon, 0, 1, '', 0, 'prebuild_adv_ignore');
	}
	else
	{
		mb_echo(SCRIPT_NAME .': This scripts requires mBot 1.0.0.0 or later!');
	}
}

function mbe_MsgIn ($cid, $body, $timestamp, $known)
{
	if ($known)
	{
		$uin								= mb_CGetUIN($cid);
		$proto								= mb_CGetProto($cid);
		$name								= mb_CIsOnList($cid) ? mb_CGetDisplayName($cid) : mb_CGetUIN($cid);
		if ($name == NULL) $name			= $uin;
		$ignore_ts							= mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreTS');
		if($ignore_ts == NULL) $ignore_ts	= 0;
		$warn_ts							= mb_CSettingGet($cid, SCRIPT_CFG, 'WarnTS');
		if($warn_ts == NULL) $warn_ts		= 0;
		
		if ($timestamp < $warn_ts)
		{
			return 'drop';
		}
		else if ($timestamp < $ignore_ts)
		{
			if (DISPLAY_POPUP)
			{
				mb_PUAdd($cid, ' ', $name .'  .', NULL, NULL, mb_IconLoadSys(IDI_INFORMATION));
			}
			if (WARN_LOG)
			{
				$file_handle = fopen(WORKING_PATH .'/AdvIgnore.log', 'a+');
				fwrite($file_handle, ''. SYM_ENTER .'['. date("d.m.Y - H:i:s",$timestamp) .'] '. $name .' ('. $uin .':'. $proto .'):'. SYM_ENTER . utf2ansi($body) . SYM_ENTER);
				fclose($file_handle);
			}
			
			if (WARN_CONTACT && my_visibility($cid))
			{
				$warn_msg = sprintf(WARN_MESSAGE, date("d.m.Y - H:i", $ignore_ts) .' ('. GMT_OFFSET .')', ceil(($ignore_ts - $timestamp) / 60));
				$ignore_reason = mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreReason');
				
				if (WARN_REASON && $ignore_reason)
				{
					$warn_msg .= SYM_ENTER .': '. $ignore_reason;
				}
				
				mb_MsgSend($cid, $warn_msg, false);
				mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_DWORD, 'WarnTS', ($timestamp + WARN_DELAY));
			}
			
			return 'drop';
		}
	}

	return 0;
}

function prebuild_adv_ignore ($cid, $hmenu)
{
	$timestamp							= time();
	$ignore_ts							= mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreTS');
	if($ignore_ts == NULL) $ignore_ts	= 0;
	
	if ($timestamp < $ignore_ts)
	{
		$menuitem_name = '[AI]  ('. date("d.m.Y - H:i", $ignore_ts) .')';
		$icon_handle = mb_IconLoadSkin(SKINICON_OTHER_USERONLINE);
	}
	else
	{
		$menuitem_name = '[AI] ';
		$icon_handle = mb_IconLoadSys(IDI_ERROR);
	}
	
	mb_MenuModify($hmenu, $menuitem_name, $icon_handle);
}

function menu_adv_ignore ($param, $cid, $hmenu)
{
	$timestamp							= time();
	$ignore_ts							= mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreTS');
	if($ignore_ts == NULL) $ignore_ts	= 0;
	
	if ($timestamp > $ignore_ts)
	{
		$ignore_duration = mb_DlgGetString('  ( ):', ' ', 0x08, 0, 0, '');
		
		if ($ignore_duration)
		{
			mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_DWORD, 'IgnoreTS', ($timestamp + ($ignore_duration * 60)));
			
			if (WARN_REASON)
			{
				$ignore_reason = mb_CSettingGet($cid, SCRIPT_CFG, 'IgnoreReason');
				$ignore_reason = mb_DlgGetString('  :', ' ', 0x02, 0, 0, $ignore_reason);
				
				if ($ignore_reason)
				{
					mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_ASCIIZ, 'IgnoreReason', $ignore_reason);
				}
			}
		}
	}
	else
	{
		mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_DWORD, 'WarnTS', 0);
		mb_CSettingAdd($cid, SCRIPT_CFG, DBVT_DWORD, 'IgnoreTS', 0);
	}
}

/* statusmodes */
function my_visibility ($cid)	// currently contacy can see me?
{
	$protocol = mb_CGetProto($cid);
	$my_status = mb_PGetMyStatus($protocol);
	$apparent_mode = mb_CSettingGet($cid, $protocol, 'ApparentMode');
	
	if (($my_status != ID_STATUS_OFFLINE) && ((($my_status != ID_STATUS_INVISIBLE) && ($apparent_mode != ID_STATUS_OFFLINE)) || (($my_status == ID_STATUS_INVISIBLE) && ($apparent_mode == ID_STATUS_ONLINE))))
	{
		return 1;
	}
	
	return 0;
}
?>